<%@ LANGUAGE="VBSCRIPT" LCID="3081"%>
<!--include file="error_function.asp"-->
<%On Error Resume Next%>
<!--include file="dbConn.asp"-->

<%
'------------------------------------------------------------------------------------------------
'EZYBONDS NOTIFICATION SCRIPT version example by Jerry Wares
'Ezybonds Notification Script Copyright 2007 Data Active Solutions Pty Ltd

'The following Notification Script is an ASP version currently in use by the Ezybonds EzyCart 
'and most probably will require some modification for your particular situation but can be
'emulated for most any shopping cart type application. It is simple enough in structure to port
'or translate the logic to other scripting lanuages - PHP, PERL, etc.

'Copyright applies and is to be used for guideline purposes only and in context of the Ezybonds
'online payment system. Comments provided.

'Please refer to www.ezymerchants.com  for a Notifcation Script testing API interface to
'test your version of the Notification Script. The testing interface is located through the
'Certified Members login in the left hand menu.

'It is also highly advisable to familiarise yourself with the overall navigational and processing
'methodology which makes up the Ezybonds online payment system by downloading the pdf "Installation
'Guide" located at www.ezymerchants.com through the "Developer Guides" button.

'*** EZYCART USER'S: If you're using or planning to use, the EzyCart then the Notification
'Script and pin code are automatically configured for you and you do not need to do anything
'further.

'Any questions, feedback, suggestions please supply to jerry@dataactive.com.au
'------------------------------------------------------------------------------------------------

'--------------------------------------------------------------------
'Declare variables
'--------------------------------------------------------------------
Dim merchantid
Dim pin_code
Dim dtDate
Dim dtDateTime
Dim hrHour
Dim notify_type
Dim custom01
Dim custom02
Dim rsMerch
Dim sql
Dim rs
Dim trans_id
Dim subtotal
Dim Check1
Dim Check2
Dim Check3
Dim Check4
Dim Check5
Dim Check6
Dim Check7
Dim confirmed
Dim acknowledged
Dim productid
Dim prod_desc
Dim amount
Dim invoice
Dim email_sent_merchant
Dim email_sent_customer

'--------------------------------------------------------------------
'Assisgn some default values
'--------------------------------------------------------------------
Check1 = False
Check2 = False
Check3 = False
Check4 = False
Check5 = False
Check6 = False
Check7 = False
confirmed = False
acknowledged = False
email_sent_merchant = False
email_sent_customer = False
subtotal = 0

'--------------------------------------------------------------------
'A set of the original payment button form values passed by form POST
'to Notification Script from Ezybonds during CHECK and PAYMENT steps.
'--------------------------------------------------------------------
merchantid 		= Trim(Request.Form("merchant"))
productid 		= Trim(Request.Form("product_id"))
prod_desc 		= Trim(Request.Form("prod_desc"))
amount 			= Trim(Request.Form("amount"))
invoice 		= Trim(Request.Form("invoice"))
custom01 		= Trim(Request.Form("custom01"))
custom02 		= Trim(Request.Form("custom02"))

'--------------------------------------------------------------------
'Ezbonds adds these additional values to the POST
'--------------------------------------------------------------------
notify_type 	= Trim(Request.Form("notify_type"))
pin_code 		= Trim(Request.Form("pin_code"))

'--------------------------------------------------------------------
'First testing if 'invoice' variable contains value.
'(INSERT or UPDATE statements require integer datatype - even if zero
'--------------------------------------------------------------------
If (isNull(Trim(invoice)) Or Trim(invoice) = "") Then invoice = 0

'--------------------------------------------------------------------
'Create a date/time for activity
'--------------------------------------------------------------------
hrHour=Hour(Time)
dtDate=Date
dtDateTime=Year(dtDate) & "/" & Month(dtDate) & "/" & Day(dtDate) & " " & hrHour & ":" & Minute(Time) & ":" & Second(Time)

'--------------------------------------------------------------------
'Test for CHECK or PAYMENT notification request from Ezybonds
'--------------------------------------------------------------------
If (notify_type = "CHECK" AND notify_type <> "") Then


'--------------------------------------------------------------------
'I record these values ahead of CHECK step processing just to have them
'for reference in case something falls over and escapes error function.
'--------------------------------------------------------------------
'sql="INSERT INTO notification_details_CHECK (merchantid, pin_code, invoice, product_id, amount, dtDateTime) VALUES(" & merchantid & ", '" & pin_code & "', " & invoice & ", '" & productid & "', " & amount & ", '" & dtDateTime & "')"
'conn.Execute(sql)

		Set rs = Server.CreateObject("ADODB.Recordset")
		With rs
    		.Open "notification_details_CHECK", conn, adOpenDynamic, adLockOptimistic
			If .State = adStateOpen Then
			.AddNew
			.Fields("merchantid")=merchantid
			.Fields("pin_code")=pin_code
			.Fields("invoice")=invoice
			.Fields("product_id")=productid
			.Fields("amount")=amount
			.Fields("dtDateTime")=dtDateTime
			.Update
			.Close
			End If	
		End With

	'--------------------------------------------------------------------
	'Now testing if EzyMerchant exists in database
	'--------------------------------------------------------------------
	set rsMerch=Server.CreateObject("ADODB.Recordset")
	sql="SELECT merchants.* FROM merchants WHERE merchants.merchantid = " & merchantid
	rsMerch.ActiveConnection=conn
	rsMerch.CursorLocation=3
	rsMerch.LockType=3
	rsMerch.Source=sql
	rsMerch.Open
	If Not (rsMerch.EOF Or rsMerch.BOF) Then
	
		Check1 = True 'EzyMerchant found and has an EzyCart account
			
			'--------------------------------------------------------------------
			'Checking if order exists based on 'invoice' value. This is where we
			'authenticate the total amount of the order as POSTED back to us in 
			'the "amount" value from Ezybonds. We fetch from the db all amounts 
			'that made up the original orders' total amount submitted by the
			'customer at the Payment Button. We want to make sure that the amount
			'that was POSTED in the form at the Payment Button is still exactly the
			'same amount that Ezybonds is now passing back to our Notification Script.
			'This insures we detect any form tampering between the merchants server
			'and the Ezybonds server. This is a mandatory authentication step
			'required by Ezybonds. This protects both the merchant and Ezybonds
			'against fraudulent attempts at <form> tampering.
			'--------------------------------------------------------------------
			set rsOrders=Server.CreateObject("ADODB.Recordset")
			sql="SELECT orders.* FROM orders WHERE orders.id=" & invoice
			'Response.Write sql&"<br><br>"
			rsOrders.ActiveConnection=conn
			rsOrders.CursorLocation=3
			rsOrders.LockType=3
			rsOrders.Source=sql
			rsOrders.Open
			
			
			If Not (rsOrders.EOF Or rsOrders.BOF) Then
				'--------------------------------------------------------------------
				'The order exists, now getting a few details
				'--------------------------------------------------------------------
				intl=rsOrders("intl")
				orderid=rsOrders("orderid")
				totalShipping=rsOrders("totalShipping")
				Check2 = True 'matching order id found
				
				'--------------------------------------------------------------------
				'Now fetching order details (line items) based on invoice or order id
				'--------------------------------------------------------------------
				Set rsOrder_details=Server.CreateObject("ADODB.Recordset")
				sql="SELECT order_details.* FROM order_details WHERE (order_details.oid=" & invoice & ")"
				'response.write sql&"<br>"
				rsOrder_details.ActiveConnection=conn
				rsOrder_details.CursorLocation=3
				rsOrder_details.LockType=3
				rsOrder_details.Source=sql
				rsOrder_details.Open
				
				While Not (rsOrder_details.EOF Or rsOrder_details.BOF)

					prod_price=rsOrder_details("item_price")
				
					totalAmount = (totalAmount + (prod_price * rsOrder_details("quantity")))
					
				rsOrder_details.MoveNext
				Wend
				rsOrder_details.Close
					
				totalAmount = (totalAmount + totalShipping)
				
				'--------------------------------------------------------------------
				'Here we are comparing the amount values between what Ezybonds POSTED
				'to our Notification Script and what was pulled from the database based
				'on the 'invoice' or order id.
				'--------------------------------------------------------------------
				If cdbl(totalAmount) = cdbl(amount) Then
				
					Check3 = True 'amounts match
					
						'--------------------------------------------------------------------
						'If we now know that the merchant exists and the order exists and the 
						'order amounts match then we can test for the pin code in our database
						'which matches the pin code POSTED by Ezybonds.
						'--------------------------------------------------------------------
						set rs=Server.CreateObject("ADODB.Recordset")
						sql="SELECT pincodes_" & rsMerch("merchantid") & ".pincode, pincodes_" & rsMerch("merchantid") & ".pincodeid FROM pincodes_" & rsMerch("merchantid") & " WHERE pincodes_" & rsMerch("merchantid") & ".pincode LIKE '" & pin_code & "'"
						'Response.Write sql&"<br><br>"
						rs.CursorLocation = 3	'adUseClient
						rs.CursorType = 3		'adOpenStatic
						rs.ActiveConnection = conn 'objConn
						rs.Open sql

						If Not (rs.EOF OR rs.BOF) Then
							Check4 = True 'Pincode found in database
							pincodeid=rs("pincodeid")
							
							'--------------------------------------------------------------------
							'The following pin code test applies to a central database table where 
							'specific details of this step are recorded and used later in the
							'EzyCart admin area. Your requirements or methodology may differ.
							'This tests if the Pin Code has previously been used or not. This is an
							'EzyCart specific redundancy test and may or may not be applicable to
							'your solution.
							'--------------------------------------------------------------------
							Set rs1=Server.CreateObject("ADODB.Recordset")
							sql="SELECT notification_details.* FROM notification_details WHERE ((notification_details.pincode_check_id=" & pincodeid & " OR notification_details.pincode_payment_id=" & pincodeid & ")  AND notification_details.merchantid=" & merchantid & ")"
							'Response.Write sql&"<br><br>"
							rs1.CursorLocation = 3	'adUseClient
							rs1.CursorType = 3		'adOpenStatic
							rs1.ActiveConnection = conn 'objConn
							rs1.Open sql

							If (rs1.EOF Or rs1.BOF) Then
			
								pincode_check_id=Trim(rs("pincodeid"))
								Check5 = True 'pin code not used

							Else
								Check5 = False 'pin code found but already used
								pincode_check_id=rs("pincodeid")
							End If
							rs1.Close
							
						Else
							Check4 = False 'matching pin code not found in database
						End If
						rs.Close
			
					Else
						Check3 = False 'amounts do not match
						pincode_check_id=0
						'response.write sql&"<br>"
					End If
			
				Else
					Check2 = False 'no matching order id found
				End If
				rsOrders.Close
	Else	
		Check1 = False 'merchant not found in database
	End If
	rsMerch.Close
	
'*********************************************************************
	'--------------------------------------------------------------------
	'Now checking the status of all conditoinal flags set during the 
	'CHECK step.
	'--------------------------------------------------------------------
	If (Check1 And Check2 And Check3 And Check4 And Check5) Then
		
		'If all flags are TRUE then we can CONFIRM the CHECK step by writing
		'the text characters "CONFIRM" to the Response header. Ezybonds receives
		'this reponse and follows it with the "PAYMENT" notification request
		'in the next section.
		Response.AddHeader "content-type", "text/html"
		Response.Write "CONFIRM"
		confirmed=True
	Else
		
		'If we detect something wrong in any of our processing then we reject
		'the transaction by writing "DECLINE" to the Response header. At this
		'point Ezybonds would end the attempted transaction and report to the
		'customer accordingly.
		Response.AddHeader "content-type", "text/html"
		Response.Write "DECLINE"
		confirmed=False
	End If

'--------------------------------------------------------------------
'The following is optional processing to a central database table where specific
'details of this step are recorded and used later in the EzyCart admin area.
'Your requirements or methodology may differ.
'--------------------------------------------------------------------
	'sql="INSERT INTO notification_details (merchantid, invoice, subtotal, amount, pincode_check_id, pincode_check_date, check1, check2, check3, check4, check5, confirmed) VALUES ('"&merchantid&"', '"&invoice&"', "&totalAmount&", "&amount&", "&pincode_check_id&", '"&dtDateTime&"', '"&check1&"', '"&check2&"', '"&check3&"', '"&check4&"', '"&check5&"', '"&confirmed&"')"
	'conn.Execute(sql)
	
Set rs = Server.CreateObject("ADODB.Recordset")
With rs
    .Open "notification_details", conn, adOpenDynamic, adLockOptimistic
	If .State = adStateOpen Then
	.AddNew
	.Fields("merchantid")=merchantid
	.Fields("invoice")=orderid 'Sequential Order or Invoice ID from the perspective of the merchant
	.Fields("oid")=invoice 'Actual id from table 'orders'
	.Fields("subtotal")=totalAmount
	.Fields("amount")=amount
	.Fields("pincode_check_id")=pincode_check_id
	.Fields("pincode_check_date")=dtDateTime
	.Fields("check1")=check1
	.Fields("check2")=check2
	.Fields("check3")=check3
	.Fields("check4")=check4
	.Fields("check5")=check5
	.Fields("confirmed")=confirmed
	.Update
	.Close
	End If	
End With


'######### PAYMENT ###########################################################################################################

'--------------------------------------------------------------------
'ABOUT THE PAYMENT REQUEST STEP
'If Ezybonds has received the "CONFIRM" response above they proceed
'to transfer the funds for the transaction from the customers EzyAccount
'to the merchants EzyAccount. They then second this second request to 
'to the Notification Script asking the EzyMerchant to "Acknowledge" the
'payment. In this request they have also POSTED the same original values
'along with a Transaction ID (trans_id) and an additional, different Pin Code.
'The second pin code should be tested in the same manner as during the CHECK
'step above. If the merchant accepts the second different pin code then
'the text characters "ACKNWOLEDGE" are written to the Response header.
'NOTE: Ezybonds will keep sending a "PAYMENT" request to the Notification Script
'until they receive the "ACKNOWLEDGE" response. The script has to be
'intelligent enough to "wait" indefinately for this request in the event of 
'power failure, etc. Any post transaction processing by the merchant should
'occur at the end of this script. There should be no other Responses
' and there should be no redirections. The customer IS NOT presented 
'with anything from this script and it should not be used to do such.
'The customer is redirected to the merchant's site by navigational options
'put to the screen independently by Ezybonds.
'--------------------------------------------------------------------

Elseif (notify_type = "PAYMENT" AND notify_type <> "") Then

	trans_id = Trim(Request.Form("trans_id"))
	
	If (isNull(Trim(trans_id)) Or Trim(trans_id) = "") Then trans_id = 0
	
	sql="INSERT INTO notification_details_PAYMENT (merchantid, pin_code, invoice, trans_id, dtDateTime) VALUES(" & merchantid & ", '" & pin_code & "', " & invoice & ", " & trans_id & ", '" & dtDateTime & "')"
	conn.Execute(sql)

	set rs=Server.CreateObject("ADODB.Recordset")
	sql="SELECT pincodes_" & merchantid & ".pincode, pincodes_" & merchantid & ".pincodeid FROM pincodes_" & merchantid & " WHERE pincodes_" & merchantid & ".pincode LIKE '" & pin_code & "'"
	'Response.Write sql & "<br><br>"
	rs.CursorLocation = 3	'adUseClient
	rs.CursorType = 3		'adOpenStatic
	rs.ActiveConnection = conn 'objConn
	rs.Open sql
	
	If Not (rs.EOF OR rs.BOF) Then
		Check6 = True 'pin code was found
		pincodeid=rs("pincodeid")
			
		Set rs1=Server.CreateObject("ADODB.Recordset")
		sql="SELECT notification_details.* FROM notification_details WHERE ((notification_details.pincode_check_id=" & pincodeid & " OR notification_details.pincode_payment_id=" & pincodeid & ")  AND notification_details.merchantid=" & merchantid & ")"
		'Response.Write sql&"<br><br>"
		rs1.CursorLocation = 3	'adUseClient
		rs1.CursorType = 3		'adOpenStatic
		rs1.ActiveConnection = conn 'objConn
		rs1.Open sql
			
		If (rs1.EOF Or rs1.BOF) Then

			Check7 = True 'pin code not used

		Else
			Check7 = False
		End If
		rs1.Close
		Set rs1 = Nothing
			
	Else
		Check6 = False
	End If
	rs.Close
	Set rs = Nothing
	
	'-------------------------------------------------------------------
	'If second, matching (different pin code than CHECK step), pin code
	'is found and has not been used prior then write the text characters
	'ACKNOWLEDGE to the Response header.
	'-------------------------------------------------------------------
	If Check6 And Check7 Then
	
		Response.AddHeader "content-type", "text/html"
		Response.Write "ACKNOWLEDGE"
		acknowledged=True
		
		Set rs = Server.CreateObject("ADODB.Recordset")
		With rs
    		.Open "notification_details", conn, adOpenDynamic, adLockOptimistic
			If .State = adStateOpen Then
			rs.Filter="oid=" & invoice
			.Fields("trans_id")=trans_id
			.Fields("pincode_payment_id")=pincodeid
			.Fields("pincode_payment_date")=dtDateTime
			.Fields("check6")=check6
			.Fields("check7")=check7
			.Fields("acknowledged")=acknowledged
			.Update
			.Close
			End If	
		End With
		
		sql="UPDATE orders SET orders.trans_id=" & trans_id & ", orders.date_payment='" & dtDateTime & "' WHERE orders.id=" & invoice
		'Response.Write sql&"<br>"
		conn.Execute(sql)
		
		Set rs=conn.Execute("SELECT orders.orderid FROM orders WHERE orders.id=" & invoice)
		orderid=rs(0)
		rs.Close
		Set rs = Nothing
		%>
		
		<!--  EzyCart specific, post transactional processing  -->
		<!--#include file="/ecommerce/order_finalise.asp"-->
		<!--#include file="/ecommerce/order_finalise_customer.asp"-->
		<%

		Set rs = Server.CreateObject("ADODB.Recordset")
		With rs
    		.Open "notification_details", conn, adOpenDynamic, adLockOptimistic
			If .State = adStateOpen Then
			rs.Filter="oid=" & invoice
			.Fields("email_sent_merchant")=email_sent_merchant
			.Fields("email_sent_customer")=email_sent_customer
			.Update
			.Close
			End If	
		End With
	Else
		acknowledged=False
	End If
	
		'---------------------------------------------------------------------------
		'Some final updates to EzyCart user database
		'---------------------------------------------------------------------------
		Set rs = Server.CreateObject("ADODB.Recordset")
		With rs
    		.Open "notification_details", conn, adOpenDynamic, adLockOptimistic
			If .State = adStateOpen Then
			rs.Filter="oid=" & invoice
			.Fields("trans_id")=trans_id
			.Fields("acknowledged")=acknowledged
			.Update
			.Close
			End If	
		End With

End If

'--------------------------------------------------------------------
'This emails an error report based on the function at top of page.
'--------------------------------------------------------------------
If Err.Number <> 0 Then
    'SendErrorEmail "ASP Error", Err.Source, Err.Number, Err.Description
End If
%>
